// Copyright (c) 2015, XMOS Ltd, All rights reserved

#include <xs1.h>
#include <platform.h>
#include <stdlib.h>
#include "debug_print.h"
#include "xassert.h"
#include "uart.h"

#define BITTIME(x) (100000000 / (x))
unsigned int seed = 1028472;

static void uart_test(client uart_tx_if i_uart_tx,
                      client uart_config_if i_tx_config,
                      unsigned baud_rate)
{
  debug_printf("TEST CONFIG:{'baud rate':%d}\n",baud_rate);
  debug_printf("Performing tx test.\n");

  timer tmr;
  int t;

  for(int i = 0; i < 64; i++)
  {
    // Store the current time in t
    tmr :> t;

    // Delay until t+some_random
    crc32(seed, -1, 0xEB31D82E);
    seed /= 100000;
    tmr when timerafter(t+seed) :> void;
    i_uart_tx.write(i);
  }
  _Exit(0);
}

port p_rx = on tile[0] : XS1_PORT_1A;
port p_tx = on tile[0] : XS1_PORT_1B;


#define BUFFER_SIZE 64
int main() {
  uart_tx_if i_tx;
  uart_config_if i_tx_config;
  output_gpio_if i_gpio_tx[1];
  par {

    on tile[0] : output_gpio(i_gpio_tx, 1, p_tx, null);
    on tile[0] : uart_tx(i_tx, i_tx_config, BAUD, UART_PARITY_NONE, 8, 1, i_gpio_tx[0]);
    on tile[0] : {
        uart_test(i_tx, i_tx_config, BAUD);
     }
   }
   return 0;
 }
